package entregas;

import java.awt.Dimension;

import javax.swing.JFrame;


@SuppressWarnings("serial")
/**
 * Programa que guarda los datos de <b>Entregas</b> de envios. Las <b>Entregas</b> se agrupan en <b>Colecciones</b>,
 * las cuáles se pueden guardar en disco para luego ser recuperadas.<br>
 * Las <b>Colecciones</b> pueden ser editadas añadiendo, modificando o eliminando <b>Entregas</b>.
 * @author Kabuto
 * @version 1.05b
 */
public final class GestionEntregas extends JFrame{
	
	public GestionEntregas() {
		super("Gestion de Entregas v1.05b");
		Controlador controlador = new Controlador();
		Modelo modelo = new Modelo();
		controlador.setModelo(modelo);
		Vista vista = new Vista(controlador);
		controlador.setVista(vista);
		setContentPane(vista.getContenedor());
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);//Antes de cerrar ventana, se comprobará si hay cambios sin guardar
		setResizable(true);
		pack();
		setLocationRelativeTo(null);
		setVisible(true);
		setMinimumSize(new Dimension(1067, 630));
		//System.out.println(this.getBounds().toString());
		addWindowListener(new java.awt.event.WindowAdapter() {
            @Override
            public void windowClosing(java.awt.event.WindowEvent evt) {
                if (controlador.avisoAntesDeCerrar())
                	System.exit(0);
            }
        });
	}

	public static void main(String[] args) {
		new GestionEntregas();
	}

}
