package paneles;

import java.awt.Color;
import java.awt.Font;

import javax.swing.GroupLayout;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.ScrollPaneConstants;

import entregas.Entrega;

import javax.swing.GroupLayout.Alignment;

@SuppressWarnings("serial")
/**
 * Modela el panel central de la interfaz que muestra los campos con los
 * datos de la <b>Entrega</b> actual.
 * @author Kabuto
 */
public final class Centro extends JPanel{
	
	private MiLabel et_acuse = new MiLabel("Numero de Acuse:");
	public MiField cam_acuse = new MiField(8);
	private MiLabel et_consig = new MiLabel("Nombre Consignatario:");
	private MiField cam_consig = new MiField(30);
	private MiLabel et_direccion = new MiLabel("Direccion Consignatario:");
	private MiField cam_direccion = new MiField(30);
	private MiLabel et_estado = new MiLabel("Estado:");
	private MiField cam_estado = new MiField(10);
	private MiLabel et_tipoServicio = new MiLabel("Tipo Servicio:");
	private MiField cam_tipoServicio = new MiField(10);
	private MiLabel et_cantidad = new MiLabel("Cantidad de Paquetes:");
	private MiField cam_cantidad = new MiField(4);
	private MiLabel et_nombreDestino = new MiLabel("Nombre Destinatario:");
	private MiField cam_nombreDestino = new MiField(30);
	private MiLabel et_direcDestino = new MiLabel("Direccion Destinatario:");
	private MiField cam_direcDestino = new MiField(30);
	private MiLabel et_municipioDestino = new MiLabel("Municipio Destinatario: ");
	private MiField cam_municipioDestino  = new MiField(10);
	private MiLabel et_fecha = new MiLabel("Fecha Entrega:");
	private MiField cam_fecha  = new MiField(8);
	private MiLabel et_observaciones = new MiLabel("Observaciones:");
	private JTextArea area_observaciones = new JTextArea(3, 10);
	private MiLabel et_baja = new MiLabel("Baja Sistema:");
	private MiField cam_baja  = new MiField(8);
	private MiLabel et_fechaEnvio = new MiLabel("Fecha Envio Destino:");
	private MiField cam_fechaEnvio  = new MiField(8);
	private MiLabel et_folioEnvio = new MiLabel("Folio Envio Destino:");
	private MiField cam_folioEnvio  = new MiField(10);
	
	public Centro() {
		area_observaciones.setLineWrap(true);
		area_observaciones.setWrapStyleWord(true);
		area_observaciones.setFont(new Font("Verdana", Font.BOLD, 14));
		area_observaciones.setForeground(Color.BLUE);
		JScrollPane jsp = new JScrollPane(area_observaciones);
		jsp.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
		jsp.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
		GroupLayout layout = new GroupLayout(this);
		setLayout(layout);
		layout.setAutoCreateGaps(true);
		layout.setAutoCreateContainerGaps(true);
		GroupLayout.SequentialGroup hGroup = layout.createSequentialGroup();
		hGroup.addGroup(layout.createParallelGroup().addComponent(et_acuse).addComponent(et_consig).addComponent(et_direccion)
				.addComponent(et_estado).addComponent(et_tipoServicio).addComponent(et_cantidad).addComponent(et_nombreDestino)
				.addComponent(et_direcDestino).addComponent(et_municipioDestino).addComponent(et_fecha).addComponent(et_observaciones)
				.addComponent(et_baja).addComponent(et_fechaEnvio).addComponent(et_folioEnvio));
		hGroup.addGroup(layout.createParallelGroup().addComponent(cam_acuse).addComponent(cam_consig).addComponent(cam_direccion)
				.addComponent(cam_estado).addComponent(cam_tipoServicio).addComponent(cam_cantidad).addComponent(cam_nombreDestino)
				.addComponent(cam_direcDestino).addComponent(cam_municipioDestino).addComponent(cam_fecha).addComponent(jsp)
				.addComponent(cam_baja).addComponent(cam_fechaEnvio).addComponent(cam_folioEnvio));
		layout.setHorizontalGroup(hGroup);
		GroupLayout.SequentialGroup vGroup = layout.createSequentialGroup();
		vGroup.addGroup(layout.createParallelGroup(Alignment.BASELINE).addComponent(et_acuse).addComponent(cam_acuse));
		vGroup.addGroup(layout.createParallelGroup(Alignment.BASELINE).addComponent(et_consig).addComponent(cam_consig));
		vGroup.addGroup(layout.createParallelGroup(Alignment.BASELINE).addComponent(et_direccion).addComponent(cam_direccion));
		vGroup.addGroup(layout.createParallelGroup(Alignment.BASELINE).addComponent(et_estado).addComponent(cam_estado));
		vGroup.addGroup(layout.createParallelGroup(Alignment.BASELINE).addComponent(et_tipoServicio).addComponent(cam_tipoServicio));
		vGroup.addGroup(layout.createParallelGroup(Alignment.BASELINE).addComponent(et_cantidad).addComponent(cam_cantidad));
		vGroup.addGroup(layout.createParallelGroup(Alignment.BASELINE).addComponent(et_nombreDestino).addComponent(cam_nombreDestino));
		vGroup.addGroup(layout.createParallelGroup(Alignment.BASELINE).addComponent(et_direcDestino).addComponent(cam_direcDestino));
		vGroup.addGroup(layout.createParallelGroup(Alignment.BASELINE).addComponent(et_municipioDestino).addComponent(cam_municipioDestino));
		vGroup.addGroup(layout.createParallelGroup(Alignment.BASELINE).addComponent(et_fecha).addComponent(cam_fecha));
		vGroup.addGroup(layout.createParallelGroup(Alignment.BASELINE).addComponent(et_observaciones).addComponent(jsp));
		vGroup.addGroup(layout.createParallelGroup(Alignment.BASELINE).addComponent(et_baja).addComponent(cam_baja));
		vGroup.addGroup(layout.createParallelGroup(Alignment.BASELINE).addComponent(et_fechaEnvio).addComponent(cam_fechaEnvio));
		vGroup.addGroup(layout.createParallelGroup(Alignment.BASELINE).addComponent(et_folioEnvio).addComponent(cam_folioEnvio));
		layout.setVerticalGroup(vGroup);
		activarCampos(false);
	}
	
	/**
	 * Activa o desactiva la edición de los campos de texto.<br>
	 * Los campos solo serán editables cuando estemos modificando o creando una
	 * nueva <b>Entrega</b>
	 * @param activar <b>boolean</b> para decidir si los campos son editables.
	 */
	public void activarCampos(boolean activar) {
		cam_acuse.setEditable(activar);
		cam_consig.setEditable(activar);
		cam_direccion.setEditable(activar);
		cam_estado.setEditable(activar);
		cam_tipoServicio.setEditable(activar);
		cam_cantidad.setEditable(activar);
		cam_nombreDestino.setEditable(activar);
		cam_direcDestino.setEditable(activar);
		cam_municipioDestino.setEditable(activar);
		cam_fecha.setEditable(activar);
		area_observaciones.setEditable(activar);
		/*
		 * El area de texto tiene un comportamiento distinto en cuanto al color
		 * respecto al resto de campos. Intentamos igualarlo cambiando su color
		 * manualmente.
		 */
		if (activar)
			area_observaciones.setBackground(Color.WHITE);
		else
			area_observaciones.setBackground(this.getBackground());
		cam_baja.setEditable(activar);
		cam_fechaEnvio.setEditable(activar);
		cam_folioEnvio.setEditable(activar);
	}
	
	/**
	 * Borra el contenido de todos los campos.
	 */
	public void resetCampos() {
		cam_acuse.setText(null);
		cam_consig.setText(null);
		cam_direccion.setText(null);
		cam_estado.setText(null);
		cam_tipoServicio.setText(null);
		cam_cantidad.setText(null);
		cam_nombreDestino.setText(null);
		cam_direcDestino.setText(null);
		cam_municipioDestino.setText(null);
		cam_fecha.setText(null);
		area_observaciones.setText(null);
		cam_baja.setText(null);
		cam_fechaEnvio.setText(null);
		cam_folioEnvio.setText(null);
	}
	
	/**
	 * Decide si los datos del formulario son válidos o no para crear una <b>Entrega</b><br>
	 * El formulario es válido si:<br><ul>
	 * <li>El <i>Número de acuse</i> no está vacío y consiste en una letra seguida de uno o más números.</li>
	 * <li>Las <i>fechas</i> pueden estar vacias. Pero si contienen algo, han de tener el formato: <i>dd/mm/aaaa</i></li>
	 * <li>El resto de campos pueden estar vacios.</li></ul><br>
	 * Si algo de esto no se cumple, se alerta al usuario y se rechaza la validez del formulario.
	 * @return <b>true</b> si es válido, <b>false</b> en caso contrario.
	 */
	public boolean validarFormulario() {
		//Validamos numero de acuse
		String txt = cam_acuse.getText(); 
		if (txt.isEmpty()){
			mostrarAlerta("<html>El campo <b>Numero de Acuse</b> no puede estar vacio.</html>");
			return false;
		}
		else if (!txt.toUpperCase().matches("[A-Z]{1}\\d+")) {
			mostrarAlerta("<html><b>Numero acuse</b> invalido.<br>Ha de comenzar por una letra y seguido de numeros.</html>");
			return false;
		}
		
		//Validamos fecha. Se acepta vacia, pero si contiene algo, ha de cumplir el formato
		String fecha = cam_fecha.getText();
		if (!fecha.isEmpty() && !fecha.matches("\\d{1,2}/\\d{1,2}/\\d{4}")) {
			mostrarAlerta("<html>Formato para el campo <u>Fecha Entrega</u> invalido.<br>Use formato: <i>dd/mm/aaaa</i></html>");
			return false;
		}
		
		//Lo mismo con fecha envio
		fecha = cam_fechaEnvio.getText();
		if (!fecha.isEmpty() && !fecha.matches("\\d{1,2}/\\d{1,2}/\\d{4}")) {
			mostrarAlerta("<html>Formato para el campo <u>Fecha Envio</u> invalido.<br>Use formato: <i>dd/mm/aaaa</i></html>");
			return false;
		}
		
		return true;
	}
	
	/**
	 * Recopila los datos del formulario y devuelve una <b>Entrega.</b>
	 * @return <b>Entrega</b> creada con los datos del formulario.
	 */
	public Entrega devuelveEntrega() {
		return new Entrega(cam_acuse.getText(), cam_consig.getText(), cam_direccion.getText(), cam_estado.getText(),
				cam_tipoServicio.getText(), cam_cantidad.getText(), cam_nombreDestino.getText(), cam_direcDestino.getText(),
				cam_municipioDestino.getText(), cam_fecha.getText(), area_observaciones.getText(), cam_baja.getText(),
				cam_fechaEnvio.getText(), cam_folioEnvio.getText());
	}
	
	/**
	 * Recibe una <b>Entrega</b> y muestra sus datos en los campos correspondientes.
	 * @param e <b>Entrega</b> a mostrar en pantalla.
	 */
	public void muestraDatosEntrega(Entrega e) {
		if (e != null) {
			cam_acuse.setText(e.getNumAcuse());
			cam_consig.setText(e.getNombreConsig());
			cam_direccion.setText(e.getDireccion());
			cam_estado.setText(e.getEstado());
			cam_tipoServicio.setText(e.getTipoServicio());
			cam_cantidad.setText(e.getCantiPaquetes());
			cam_nombreDestino.setText(e.getNomDestinatario());
			cam_direcDestino.setText(e.getDirecDestinatario());
			cam_municipioDestino.setText(e.getMunicipioDestinatario());
			cam_fecha.setText(e.getFecha());
			area_observaciones.setText(e.getObservaciones());
			cam_baja.setText(e.getBajaSistema());
			cam_fechaEnvio.setText(e.getFechaEnvioDestino());
			cam_folioEnvio.setText(e.getFolioEnvioDestino());
		}
		else {
			resetCampos();
			activarCampos(false);
		}
	}
	
	
	//Metodos internos
	private void mostrarAlerta(String mensaje) {
		JOptionPane.showMessageDialog(null, mensaje, "Atencion", JOptionPane.WARNING_MESSAGE);
	}
	
	//Clases internas
	/**
	 * Clase que hereda de <b>JLabel</b> y que usa una fuente de texto
	 * predeterminada.
	 * @author Kabuto
	 */
	private class MiLabel extends JLabel {
		public MiLabel(String txt) {
			super(txt);
			setFont(new Font("Verdana", Font.BOLD, 14));
		}
	}
	
	/**
	 * Clase que hereda de <b>JTextField</b> y que usa una fuente de texto
	 * predeterminada.
	 * @author Kabuto
	 */
	public class MiField extends JTextField {
		public MiField(int col) {
			super(col);
			setFont(new Font("Verdana", Font.BOLD, 14));
			this.setForeground(Color.BLUE);
		}
	}

}
